<?php
/**
 * @copyright	Copyright (C) 2011 Simplify Your Web, Inc. All rights reserved.
 * @license		GNU General Public License version 3 or later; see LICENSE.txt
 */

// no direct access
defined('_JEXEC') or die;

jimport('joomla.application.categories');

class modTrombinoscopeHelper
{	
	protected static $lookup;
	
	static function getContacts($params, $module)
	{
		$params->def('selection', 'categories');
		$params->def('contact_id', '');
		$params->def('category', '');
		$params->def('includesubcategories', 'no');
		$params->def('cat_order', '');
		$params->def('order', 'cd.ordering');
		$params->def('count', '');
		$params->def('address_format', 'zss');		
		$params->def('field1', 'none');
		$params->def('field2', 'none');
		$params->def('field3', 'none');
		$params->def('field4', 'none');
		$params->def('field5', 'none');
		
		// contact selection
		$selection = $params->get('selection', 'categories');
		
		$contact_id = $params->get('contact_id', '');
				
		// categories
		
		$categories = '';
		$categories_array = $params->get('category', array());
		
		$array_of_category_values = array_count_values($categories_array);
		if (isset($array_of_category_values['all']) && $array_of_category_values['all'] > 0) { // 'all' was selected
			// keep categories = ''
		} else {
			// sub-category inclusion
			$get_sub_categories = $params->get('includesubcategories', 'no');
			if ($get_sub_categories != 'no') {
				$categories_object = JCategories::getInstance('Contact');
				foreach ($categories_array as $category) {
					$category_object = $categories_object->get($category);
					if ($category_object->hasChildren()) {
						if ($get_sub_categories == 'all') {
							$sub_categories_array = $category_object->getChildren(true); // true is for recursive
						} else {
							$sub_categories_array = $category_object->getChildren();
						}
						foreach ($sub_categories_array as $subcategory_object) {
							$categories_array[] = $subcategory_object->id;
						}
					}
			
				}
			
				$categories_array = array_unique($categories_array);
			}
			
			if (!empty($categories_array)) {
				$categories = implode(',', $categories_array);
			}
		}
		
		$user	= JFactory::getUser();
		$groups	= implode(',', $user->getAuthorisedViewLevels());
		
		// get database
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		
		$subquery = ' CASE WHEN ';
		$subquery .= $query->charLength('cd.alias');
		$subquery .= ' THEN ';
		$cd_id = $query->castAsChar('cd.id');
		$subquery .= $query->concatenate(array($cd_id, 'cd.alias'), ':');
		$subquery .= ' ELSE ';
		$subquery .= $cd_id.' END AS slug';
		
		$subquery2 = ' CASE WHEN ';
		$subquery2 .= $query->charLength('cc.alias');
		$subquery2 .= ' THEN ';
		$cc_id = $query->castAsChar('cc.id');
		$subquery2 .= $query->concatenate(array($cc_id, 'cc.alias'), ':');
		$subquery2 .= ' ELSE ';
		$subquery2 .= $cc_id.' END AS catslug';
				
		$subqueryfield1 = modTrombinoscopeHelper::getSubQuery($params->get('field1'), $params->get('address_format'), '1');
		$subqueryfield2 = modTrombinoscopeHelper::getSubQuery($params->get('field2'), $params->get('address_format'), '2');
		$subqueryfield3 = modTrombinoscopeHelper::getSubQuery($params->get('field3'), $params->get('address_format'), '3');
		$subqueryfield4 = modTrombinoscopeHelper::getSubQuery($params->get('field4'), $params->get('address_format'), '4');
		$subqueryfield5 = modTrombinoscopeHelper::getSubQuery($params->get('field5'), $params->get('address_format'), '5');
		
		//$query->select('cd.id, cd.catid, cd.name, cd.image,'.$subquery.','.$subquery2.','.$subquery3.','.$subquery4.$subqueryfield1.$subqueryfield2.$subqueryfield3.$subqueryfield4.$subqueryfield5);	
		$query->select('cd.id, cd.catid, trim(cd.name) as name, cc.lft as c_order, cd.image,'.$subquery.','.$subquery2.$subqueryfield1.$subqueryfield2.$subqueryfield3.$subqueryfield4.$subqueryfield5);
		
		$query->from('#__contact_details AS cd');
		$query->join('INNER', '#__categories AS cc ON cd.catid = cc.id');
		
		if ($selection == 'categories' && $categories !== null) {
			if ($categories != '') {
				$query->where('cd.catid IN ('.$categories.')');
			} // else we show all categories
		} else if ($selection == 'contact' && !empty($contact_id)) {
			$query->where('cd.id='.$contact_id);
		} else if ($selection == 'user' && $user->id > 0) {
			$query->where('cd.user_id='.$user->id);
		} else {
			return null;
		}
		
		$nullDate = $db->Quote($db->getNullDate());
		$nowDate = $db->Quote(JFactory::getDate()->toSql());
		$query->where('cd.published = 1');
		$query->where('(cd.publish_up = ' . $nullDate . ' OR cd.publish_up <= ' . $nowDate . ')');
		$query->where('(cd.publish_down = ' . $nullDate . ' OR cd.publish_down >= ' . $nowDate . ')');
				
		$query->where('cd.access IN ('.$groups.')');
		$query->where('cc.access IN ('.$groups.')');		
		
		$cat_order = $params->get('cat_order');
		$order = $params->get('order');
		switch ($order) {
			case 'cd.ordering ASC' :
			case 'cd.ordering DESC' :
			case 'cd.name ASC' :
			case 'cd.name DESC' : 
				if ($cat_order != '') {
					$query->order($cat_order.','.$order);
				} else {
					$query->order($order);
				}
				break;
			case 'sna' : $query->order($db->escape('cd.sortname1').' ASC');
				$query->order($db->escape('cd.sortname2').' ASC');
				$query->order($db->escape('cd.sortname3').' ASC'); 
				break;
			case 'snd' : $query->order($db->escape('cd.sortname1').' DESC');
				$query->order($db->escape('cd.sortname2').' DESC');
				$query->order($db->escape('cd.sortname3').' DESC'); 
				break;
			default:
				if ($cat_order != '') {
					$query->order($cat_order);
				}
				break;
		}
		
		$db->setQuery($query);
		
		$list = $db->loadObjectList();
		
		if ($error = $db->getErrorMsg()) {
			throw new Exception($error);
		}
		
		foreach ($list as $item) {
			$item->firstpart = self::_substring_index($item->name, ' ', 1);
			$item->lastpart = self::_substring_index($item->name, ' ', -1);
		}

		if ($cat_order == 'cc.lft ASC') {
			switch ($order) {
				case 'lastpart ASC,firstpart ASC' : usort($list, "modTrombinoscopeHelper::sortCascLascFasc"); break;
				case 'lastpart DESC,firstpart DESC' : usort($list, "modTrombinoscopeHelper::sortCascLdescFdesc"); break;
				case 'firstpart ASC,lastpart ASC' : usort($list, "modTrombinoscopeHelper::sortCascFascLasc"); break;
				case 'firstpart DESC,lastpart DESC' : usort($list, "modTrombinoscopeHelper::sortCascFdescLdesc"); break;
				default: break;
			}
		} else if ($cat_order == 'cc.lft DESC') {
			switch ($order) {
				case 'lastpart ASC,firstpart ASC' : usort($list, "modTrombinoscopeHelper::sortCdescLascFasc"); break;
				case 'lastpart DESC,firstpart DESC' : usort($list, "modTrombinoscopeHelper::sortCdescLdescFdesc"); break;
				case 'firstpart ASC,lastpart ASC' : usort($list, "modTrombinoscopeHelper::sortCdescFascLasc"); break;
				case 'firstpart DESC,lastpart DESC' : usort($list, "modTrombinoscopeHelper::sortCdescFdescLdesc"); break;
				default: break;
			}
		} else {
			switch ($order) {
				case 'lastpart ASC,firstpart ASC' : usort($list, "modTrombinoscopeHelper::sortLascFasc"); break;
				case 'lastpart DESC,firstpart DESC' : usort($list, "modTrombinoscopeHelper::sortLdescFdesc"); break;
				case 'firstpart ASC,lastpart ASC' : usort($list, "modTrombinoscopeHelper::sortFascLasc"); break;
				case 'firstpart DESC,lastpart DESC' : usort($list, "modTrombinoscopeHelper::sortFdescLdesc"); break;
				default: break;
			}
		}
		
		if (intval($params->get('count')) > 0) {
			// get subset of the the data
			$list = array_slice($list, 0, intval($params->get('count')), true);
		}
		
		return $list;
	}
	
	/* sort by category ASC lastpart ASC firstpart ASC */
	protected static function sortCascLascFasc($a, $b) {
	
		if ($a->c_order == $b->c_order) {
			if ($a->lastpart == $b->lastpart) {
				if ($a->firstpart == $b->firstpart) {
					return 0;
				}
				return ($a->firstpart < $b->firstpart) ? -1 : 1;
			}
			return ($a->lastpart < $b->lastpart) ? -1 : 1;
		}
		return ($a->c_order < $b->c_order) ? -1 : 1;
	}
	
	/* sort by category ASC by lastpart DESC firstpart DESC */
	protected static function sortCascLdescFdesc($a, $b) {
	
		if ($a->c_order == $b->c_order) {
			if ($a->lastpart == $b->lastpart) {			 
				if ($a->firstpart == $b->firstpart) {
					return 0;
				}
				return ($a->firstpart > $b->firstpart) ? -1 : 1;
			}
			return ($a->lastpart > $b->lastpart) ? -1 : 1;
		}
		return ($a->c_order < $b->c_order) ? -1 : 1;
	}
	
	/* sort by category ASC by firstpart ASC lastpart ASC */
	protected static function sortCascFascLasc($a, $b) {
	
		if ($a->c_order == $b->c_order) {
			if ($a->firstpart == $b->firstpart) {			 
				if ($a->lastpart == $b->lastpart) {
					return 0;
				}				
				return ($a->lastpart < $b->lastpart) ? -1 : 1;
			}
			return ($a->firstpart < $b->firstpart) ? -1 : 1;
		}
		return ($a->c_order < $b->c_order) ? -1 : 1;
	}
	
	/* sort by by category ASC firstpart DESC lastpart DESC */
	protected static function sortCascFdescLdesc($a, $b) {
	
		if ($a->c_order == $b->c_order) {
			if ($a->firstpart == $b->firstpart) {			 
				if ($a->lastpart == $b->lastpart) {
					return 0;
				}
				return ($a->lastpart > $b->lastpart) ? -1 : 1;
			}
			return ($a->firstpart > $b->firstpart) ? -1 : 1;
		}
		return ($a->c_order < $b->c_order) ? -1 : 1;
	}
	
	/* sort by category DESC lastpart ASC firstpart ASC */
	protected static function sortCdescLascFasc($a, $b) {
	
		if ($a->c_order == $b->c_order) {
			if ($a->lastpart == $b->lastpart) {
				if ($a->firstpart == $b->firstpart) {
					return 0;
				}
				return ($a->firstpart < $b->firstpart) ? -1 : 1;
			}
			return ($a->lastpart < $b->lastpart) ? -1 : 1;
		}
		return ($a->c_order > $b->c_order) ? -1 : 1;
	}
	
	/* sort by category DESC by lastpart DESC firstpart DESC */
	protected static function sortCdescLdescFdesc($a, $b) {
	
		if ($a->c_order == $b->c_order) {
			if ($a->lastpart == $b->lastpart) {
				if ($a->firstpart == $b->firstpart) {
					return 0;
				}
				return ($a->firstpart > $b->firstpart) ? -1 : 1;
			}
			return ($a->lastpart > $b->lastpart) ? -1 : 1;
		}
		return ($a->c_order > $b->c_order) ? -1 : 1;
	}
	
	/* sort by category DESC by firstpart ASC lastpart ASC */
	protected static function sortCdescFascLasc($a, $b) {
	
		if ($a->c_order == $b->c_order) {
			if ($a->firstpart == $b->firstpart) {
				if ($a->lastpart == $b->lastpart) {
					return 0;
				}
				return ($a->lastpart < $b->lastpart) ? -1 : 1;
			}
			return ($a->firstpart < $b->firstpart) ? -1 : 1;
		}
		return ($a->c_order > $b->c_order) ? -1 : 1;
	}
	
	/* sort by category DESC by firstpart DESC lastpart DESC */
	protected static function sortCdescFdescLdesc($a, $b) {
	
		if ($a->c_order == $b->c_order) {
			if ($a->firstpart == $b->firstpart) {
				if ($a->lastpart == $b->lastpart) {
					return 0;
				}
				return ($a->lastpart > $b->lastpart) ? -1 : 1;
			}
			return ($a->firstpart > $b->firstpart) ? -1 : 1;
		}
		return ($a->c_order > $b->c_order) ? -1 : 1;
	}
	
	/* sort by lastpart ASC firstpart ASC */
	protected static function sortLascFasc($a, $b) {
	
		if ($a->lastpart == $b->lastpart) {
			if ($a->firstpart == $b->firstpart) {
				return 0;
			}
			return ($a->firstpart < $b->firstpart) ? -1 : 1;
		}
		return ($a->lastpart < $b->lastpart) ? -1 : 1;
	}
	
	/* sort by lastpart DESC firstpart DESC */
	protected static function sortLdescFdesc($a, $b) {
	
		if ($a->lastpart == $b->lastpart) {
			if ($a->firstpart == $b->firstpart) {
				return 0;
			}
			return ($a->firstpart > $b->firstpart) ? -1 : 1;
		}
		return ($a->lastpart > $b->lastpart) ? -1 : 1;
	}
	
	/* sort by firstpart ASC lastpart ASC */
	protected static function sortFascLasc($a, $b) {
	
		if ($a->firstpart == $b->firstpart) {
			if ($a->lastpart == $b->lastpart) {
				return 0;
			}
			return ($a->lastpart < $b->lastpart) ? -1 : 1;
		}
		return ($a->firstpart < $b->firstpart) ? -1 : 1;
	}
	
	/* sort by firstpart DESC lastpart DESC */
	protected static function sortFdescLdesc($a, $b) {
	
		if ($a->firstpart == $b->firstpart) {
			if ($a->lastpart == $b->lastpart) {
				return 0;
			}
			return ($a->lastpart > $b->lastpart) ? -1 : 1;
		}
		return ($a->firstpart > $b->firstpart) ? -1 : 1;
	}
	
	static function getSubQuery($field, $format, $index)
	{		
		$subquery = '';
		
		if ($field != "none") {
			$subquery .= ', ';
			if ($field == "empty") {
				$subquery .= "'empty' AS field".$index.", 'empty' AS fieldname".$index;
			} else if ($field == "formattedaddress") {
		
				$subqueryformattedaddress = '';
				
				switch ($format) {
					case 'ssz' :
						$subqueryformattedaddress = "CONCAT(cd.suburb, ', ', cd.state, ' ', cd.postcode)";
						break;
					case 'zss' :
						$subqueryformattedaddress = "CONCAT(cd.postcode, ' ', cd.suburb, ', ', cd.state)";
						break;
					case 'zs' :
						$subqueryformattedaddress = "CONCAT(cd.postcode, ' ', cd.suburb)";
						break;
					case 'sz' :
						$subqueryformattedaddress = "CONCAT(cd.suburb, ' ', cd.postcode)";
						break;
					case 'ss' :
						$subqueryformattedaddress = "CONCAT(cd.suburb, ', ', cd.state)";
						break;						
					default :
						$subqueryformattedaddress = '';
					break;
				}
				
				$subquery .= $subqueryformattedaddress." AS field".$index.", 'formattedaddress' AS fieldname".$index;
			} else {
				$subquery .= $field." AS field".$index.", '".$field."' AS fieldname".$index;
			}
		}
				
		return $subquery;
	}
	
	static function getFieldOutput($field, $fieldname, $keepspace, $index) 
	{		
		$html = '';
				
		// field is empty (null) if 'none' is selected or no information has been found in the database, except for formatted address...
		
		if ($fieldname == "formattedaddress") { // trim the field if it contains nothing 
			$elements = preg_split ('/[\s]*[,][\s]*/', $field); // deals with "elt1  ,elt2,   elt3  "
				
			$i = 0;
			$unique_element = '';
			foreach ($elements as $element) {
				if (!empty($element)) {
					$unique_element = $element;
					$i++;
				}
			}
			// to avoid commas or spaces if missing info
			if ($i == 0) {
				$field = '';
			} else if ($i == 1) {
				$field = $unique_element;
			}	
		}
		
		if (!empty($field)) {
			$html .= '<div class="personfield'.$index.'">';
			
			switch ($fieldname) {
				case 'cd.con_position' :
					$html .= '    <span class="personposition">'.$field.'</span>';
					break;
				case 'cd.telephone' :
					$html .= '    <span class="persontel">'.$field.'</span>';
					break;
				case 'cd.mobile' :
					$html .= '    <span class="personmobile">'.$field.'</span>';
					break;
				case 'cd.fax' :
					$html .= '    <span class="personfax">'.$field.'</span>';
					break;
				case 'cd.email_to' :
					$html .= '    <a class="personemail" href="mailto:'.$field.'" title="'.$field.'">';
					$html .= '        <span>'.$field.'</span>';
					$html .= '    </a>';
					break;
				case 'cd.webpage' :
					$html .= '    <a class="personwebpage" href="'.$field.'" target="_blank" title="'.$field.'">';
					$html .= '        <span>'.$field.'</span>';
					$html .= '    </a>';
					break;
				case 'cd.address' :
					$html .= '    <span class="personaddress">'.nl2br($field).'</span>';
					break;
				case 'cd.suburb' :
					$html .= '    <span class="personsuburb">'.$field.'</span>';
					break;
				case 'cd.state' :
					$html .= '    <span class="personstate">'.$field.'</span>';
					break;
				case 'cd.country' :
					$html .= '    <span class="personcountry">'.$field.'</span>';
					break;
				case 'cd.misc' :
					$html .= '    <div class="personmiscinfo">'.$field.'</div>';
					break;
				case 'formattedaddress' :
					$html .= '    <span class="personformattedaddress">'.$field.'</span>';
					break;
				default :
					$html .= '    <span class="_empty">&nbsp;</span>'; // 'empty' field
					break;
			}
			
			$html .= '</div>';
		} else if ($keepspace) {
			$html .= '<div class="personfield'.$index.'">';			
			
			switch ($fieldname) {
				case 'cd.con_position' :
					$html .= '    <span class="personposition_empty">&nbsp;</span>';
					break;
				case 'cd.telephone' :
					$html .= '    <span class="persontel_empty">&nbsp;</span>';
					break;
				case 'cd.mobile' :
					$html .= '    <span class="personmobile_empty">&nbsp;</span>';
					break;
				case 'cd.fax' :
					$html .= '    <span class="personfax_empty">&nbsp;</span>';
					break;
				case 'cd.email_to' :
					$html .= '    <span class="personemail_empty">&nbsp;</span>';
					break;
				case 'cd.webpage' :
					$html .= '    <span class="personwebpage_empty">&nbsp;</span>';
					break;
				case 'cd.address' :
					$html .= '    <span class="personaddress_empty">&nbsp;</span>';
					break;
				case 'cd.suburb' :
					$html .= '    <span class="personsuburb_empty">&nbsp;</span>';
					break;
				case 'cd.state' :
					$html .= '    <span class="personstate_empty">&nbsp;</span>';
					break;
				case 'cd.country' :
					$html .= '    <span class="personcountry_empty">&nbsp;</span>';
					break;
				case 'cd.misc' :
					$html .= '    <div class="personmiscinfo_empty">&nbsp;</div>';
					break;
				case 'formattedaddress' :
					$html .= '    <span class="personformattedaddress_empty">&nbsp;</span>';
					break;				
				default :
					break;
			}	
			
			$html .= '</div>';
		}				
		
		return $html;
	}
	
	/**
	* Create the contact link
	*/
	public static function getContactRoute($id, $catid, $extraoptions = '')
	{
		$needles = array(
			'contact'  => array((int) $id)
		);

		$link = 'index.php?option=com_contact&view=contact&id='.$id.$extraoptions;
		if ($catid > 1) {
			$categories = JCategories::getInstance('Contact');
			$category = $categories->get($catid);
			if ($category) {
				$needles['category'] = array_reverse($category->getPath());
				$needles['categories'] = $needles['category'];
				$link .= '&catid='.$catid;
			}
		}
		
		if ($item = self::_findItem($needles)) {
			$link .= '&Itemid='.$item;
		} elseif ($item = self::_findItem()) {
			$link .= '&Itemid='.$item;
		} else {
			$link .= '&Itemid=0';
		}
	
		return $link;
	}
	
	protected static function _findItem($needles = null)
	{
		$app		= JFactory::getApplication();
		$menus		= $app->getMenu('site');
	
		// Prepare the reverse lookup array.
		if (self::$lookup === null) {
			self::$lookup = array();
	
			$component	= JComponentHelper::getComponent('com_contact');
			$items		= $menus->getItems('component_id', $component->id);
			if ($items != null) {			
				foreach ($items as $item) {
					if (isset($item->query) && isset($item->query['view'])) {
						$view = $item->query['view'];
						if (!isset(self::$lookup[$view])) {
							self::$lookup[$view] = array();
						}
						if (isset($item->query['id'])) {
							self::$lookup[$view][$item->query['id']] = $item->id;
						}
					}
				}
			}
		}
	
		if ($needles) {
			foreach ($needles as $view => $ids) {
				if (isset(self::$lookup[$view])) {
					foreach($ids as $id) {
						if (isset(self::$lookup[$view][(int)$id])) {
							return self::$lookup[$view][(int)$id];
						}
					}
				}
			}
		} 
	
		return null;
	}
	
	protected static function _substring_index($subject, $delim, $count)
	{
	    if ($count < 0) {
	        return implode($delim, array_slice(explode($delim, $subject), $count));
	    } else {
	        return implode($delim, array_slice(explode($delim, $subject), 0, $count));
	    }
	}

}
